$AdaptO = 2;
$AdaptD = 1;

package ProjectAlpha {

// WARNING!  THIS MAY HAVE TO BE RESCRIPTED FOR A PATCH!
function RepairPackImage::onActivate(%data, %obj, %slot)
{
   // don't activate the pack if player is piloting a vehicle
   if(%obj.isPilot())
   {
      %obj.setImageTrigger(%slot, false);
      return;
   }

   if(!isObject(%obj.getMountedImage($WeaponSlot)) || %obj.getMountedImage($WeaponSlot).getName() !$= "RepairGunImage")
   {
         %calc = mFloor((RepairGunImage.repairFactorObject / 0.004) * 10000) / 100;
         messageClient(%obj.client, 'MsgRepairPackOn', '\c2Repair pack activated.  Power level: %1 percent', %calc);

      // make sure player's arm thread is "look"
      %obj.setArmThread(look);

      // mount the repair gun
      %obj.mountImage(RepairGunImage, $WeaponSlot);
      // clientCmdsetRepairReticle found in hud.cs
      commandToClient(%obj.client, 'setRepairReticle');
   }
}

function Armor::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %mineSC)
{
//error("Armor::damageObject( "@%data@", "@%targetObject@", "@%sourceObject@", "@%position@", "@%amount@", "@%damageType@", "@%momVec@" )");
   if(%targetObject.invincible || %targetObject.getState() $= "Dead")
      return;

   if (%targetObject.isMounted() && %targetObject.scriptKilled $= "")
   {
      %mount = %targetObject.getObjectMount();
      if(%mount.team == %targetObject.team)
      {
         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }

         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found])
            {
               %mount.getDataBlock().damageObject(%mount, %sourceObject, %position, %amount, %damageType);
               return;
            }
         }
      }
   }

   %targetClient = %targetObject.getOwnerClient();
   if(isObject(%mineSC))
      %sourceClient = %mineSC;   
   else
      %sourceClient = isObject(%sourceObject) ? %sourceObject.getOwnerClient() : 0;

   %targetTeam = %targetClient.team;

   //if the source object is a player object, player's don't have sensor groups
   // if it's a turret, get the sensor group of the target
   // if its a vehicle (of any type) use the sensor group
   if (%sourceClient)
      %sourceTeam = %sourceClient.getSensorGroup();
   else if(%damageType == $DamageType::Suicide)
      %sourceTeam = 0;
   else if(isObject(%sourceObject) && %sourceObject.getClassName() $= "Turret")
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else if( isObject(%sourceObject) &&
   	( %sourceObject.getClassName() $= "FlyingVehicle" || %sourceObject.getClassName() $= "WheeledVehicle" || %sourceObject.getClassName() $= "HoverVehicle"))
      %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
   else
   {
      if (isObject(%sourceObject) && %sourceObject.getTarget() >= 0 )
      {
         %sourceTeam = getTargetSensorGroup(%sourceObject.getTarget());
      }
      else
      {
         %sourceTeam = -1;
      }
   }

   // if teamdamage is off, and both parties are on the same team
   // (but are not the same person), apply no damage
   if(!$teamDamage && (%targetClient != %sourceClient) && (%targetTeam == %sourceTeam))
      return;

   if(%targetObject.isShielded && %damageType != $DamageType::Blaster)
      %amount = %data.checkShields(%targetObject, %position, %amount, %damageType);

   if(%amount == 0)
      return;

      if ((%targetTeam == %sourceTeam) || (%targetClient == %sourceClient) || (%sourceTeam == 0) || (%damageType == $DamageType::Blaster))
      {
         // Don't apply Adaptive Power for TK/Suicide hits
         // Also, blaster remains the same in power for the entire map
      }
      else if ((%targetTeam == Game.offenseTeam) && (%damageType != $DamageType::Shocklance))
      {
         // Player on offense: wimpen the attack if it wasn't to self
         %amount = %amount / ((100 + ($Adapt * $AdaptO)) / 100);
      }
      else if ((%targetTeam == Game.offenseTeam) && (%damageType == $DamageType::Shocklance))
      {
         // Shocklance loses strength half as fast as other weapons...
         %amount = %amount / ((100 + ($Adapt * ($AdaptO * 2))) / 100);
      }
      else
      {
         // Player either on defense or something screwy's going on...
         %amount = %amount * ((100 + ($Adapt * $AdaptD)) / 100);
         // If it IS something screwy, kill him now and ask questions later
      }

   // Set the damage flash
   %damageScale = %data.damageScale[%damageType];
   if(%damageScale !$= "")
      %amount *= %damageScale;
   
   %flash = %targetObject.getDamageFlash() + (%amount * 2);
   if (%flash > 0.75)
      %flash = 0.75;
   
   %previousDamage = %targetObject.getDamagePercent();
   %targetObject.setDamageFlash(%flash);
   %targetObject.applyDamage(%amount);
   Game.onClientDamaged(%targetClient, %sourceClient, %damageType, %sourceObject);

   %targetClient.lastDamagedBy = %damagingClient;
   %targetClient.lastDamaged = getSimTime();
   
   //now call the "onKilled" function if the client was... you know...  
   if(%targetObject.getState() $= "Dead")
   {
      // where did this guy get it?
      %damLoc = %targetObject.getDamageLocation(%position);
      
      // should this guy be blown apart?
      if( %damageType == $DamageType::Explosion || 
          %damageType == $DamageType::TankMortar ||
          %damageType == $DamageType::Mortar ||
          %damageType == $DamageType::MortarTurret ||
          %damageType == $DamageType::BomberBombs ||
          %damageType == $DamageType::SatchelCharge ||
          %damageType == $DamageType::Missile )     
      {
         if( %previousDamage >= 0.35 ) // only if <= 35 percent damage remaining
         {
            %targetObject.setMomentumVector(%momVec);
            %targetObject.blowup(); 
         }
      }
   
      // this should be funny...
      if( %damageType == $DamageType::VehicleSpawn )
      {   
         %targetObject.setMomentumVector("0 0 1");
         %targetObject.blowup();
      }
      
      // If we were killed, max out the flash
      %targetObject.setDamageFlash(0.75);
      
      %damLoc = %targetObject.getDamageLocation(%position);
      Game.onClientKilled(%targetClient, %sourceClient, %damageType, %sourceObject, %damLoc);
   }
   else if ( %amount > 0.1 )
   {   
      if( %targetObject.station $= "" && %targetObject.isCloaked() )
      {
         %targetObject.setCloaked( false );
         %targetObject.reCloak = %targetObject.schedule( 500, "setCloaked", true ); 
      }
      
      playPain( %targetObject );
   }
}

function SiegeGame::startMatch(%game)
{
   Parent::startMatch( %game );
   
   $Adapt = 0;
   schedule(10000,0,AdaptiveSiege,1);
   $AdaptRound = 1;
}

function AdaptiveSiege(%round)
{
   if ($AdaptRound != %round)
      return;

   $Adapt++;
   // Next two lines weakens repair pack over time
   if (RepairGunImage.repairFactorObject > 0.00005)
       RepairGunImage.repairFactorObject = RepairGunImage.repairFactorObject - 0.00005;
   schedule(10000,0,AdaptiveSiege,$AdaptRound);
}

function SiegeGame::startSecondHalf(%game)
{
    Parent::startSecondHalf(%game);

    $Adapt = 0;
    schedule(10000,0,AdaptiveSiege,2);
    $AdaptRound = 2;
}

function SiegeGame::halftime(%game, %reason)
{
   RepairGunImage.repairFactorObject = 0.004;

   Parent::halftime(%game, %reason);
}

function SiegeGame::gameOver(%game)
{
   $AdaptRound = 0;
   RepairGunImage.repairFactorObject = 0.004;

   Parent::gameOver(%game);
   deactivatepackage(ProjectAlpha);
}

};
